diff -uNr jfbterm-0.4.7.orig/ChangeLog jfbterm-0.4.7/ChangeLog
--- jfbterm-0.4.7.orig/ChangeLog	2005-02-25 00:01:05.000000000 +0900
+++ jfbterm-0.4.7/ChangeLog	2005-12-17 12:41:37.000000000 +0900
@@ -1,8 +1,14 @@
-2005-02-24  ukai  <ukai@debian.or.jp>
+2005-03-12  Fumitoshi UKAI  <ukai@debian.or.jp>
+
+	* fix some lockup problem, reported by Kenshi Muto
+	* main.c (tapp_init): SIGCHLD to wait for gunzip processes.
+	* term.h (sigchld): used in main.c:tapp_init
+
+2005-02-24  Fumitoshi UKAI  <ukai@debian.or.jp>
 
 	* version 0.4.7 released
 
-2005-02-24  ukai  <ukai@debian.or.jp>
+2005-02-24  Fumitoshi UKAI  <ukai@debian.or.jp>
 
 	* font.c (font_open): dont use popen(3) to fix local exploit.
 
diff -uNr jfbterm-0.4.7.orig/Makefile.am jfbterm-0.4.7/Makefile.am
--- jfbterm-0.4.7.orig/Makefile.am	2003-09-14 05:58:53.000000000 +0900
+++ jfbterm-0.4.7/Makefile.am	2005-12-17 12:41:37.000000000 +0900
@@ -13,8 +13,13 @@
 		term.c term.h \
 		util.c util.h \
 		csv.c csv.h \
-		vterm.c vtermlow.c vterm.h
+		vterm.c vtermlow.c vterm.h \
+		hinput.c hinput.h \
+		conv.c conv.h \
+		scrollback.c scrollback.h
 jfbterm_LDADD = -lutil
+AM_LDFLAGS = @LDFLAGS@
+AM_CFLAGS = @CFLAGS@
 
 JFBTERM_CONFIG_FILE = jfbterm.conf.sample
 
@@ -25,6 +30,12 @@
 	chmod ug+s $(DESTDIR)$(bindir)/jfbterm
 
 install-data-local:
+	$(INSTALL_DATA) -d $(DESTDIR)$(sysconfdir)
 	$(INSTALL_DATA) $(srcdir)/$(JFBTERM_CONFIG_FILE) $(DESTDIR)$(sysconfdir)/$(JFBTERM_CONFIG_FILE)
-	$(INSTALL_DATA) $(srcdir)/fonts/*.pcf.gz $(DESTDIR)$(datadir)/fonts/jfbterm
+	$(INSTALL_DATA) -d $(DESTDIR)$(datadir)/fonts/jfbterm
+	$(INSTALL_DATA) $(srcdir)/fonts/vt100-graphics.pcf.gz $(DESTDIR)$(datadir)/fonts/jfbterm/vt100-graphics.pcf.gz
+
+uninstall-local:
+	rm -f $(DESTDIR)$(sysconfdir)/$(JFBTERM_CONFIG_FILE)
+	rm -f $(DESTDIR)$(datadir)/fonts/jfbterm/vt100-graphics.pcf.gz
 
diff -uNr jfbterm-0.4.7.orig/acconfig.h jfbterm-0.4.7/acconfig.h
--- jfbterm-0.4.7.orig/acconfig.h	2003-09-04 04:11:26.000000000 +0900
+++ jfbterm-0.4.7/acconfig.h	2005-12-17 12:41:37.000000000 +0900
@@ -65,5 +65,17 @@
 /* Supprt Dimmer (Screen blank) */
 #undef JFB_ENABLE_DIMMER
 
+/* Support beep */
+#undef JFB_ENABLE_BEEP
+
+/* Support blinking cursor */
+#undef JFB_ENABLE_CURSOR_BLINK
+
+/* Support console scrollback emulation */
+#undef JFB_ENABLE_SCROLLBACK
+
+/* Support libhangul input */
+#undef JFB_WITH_LIBHANGUL
+
 /* Support reverse video */
 #undef JFB_REVERSEVIDEO
diff -uNr jfbterm-0.4.7.orig/config.h.in jfbterm-0.4.7/config.h.in
--- jfbterm-0.4.7.orig/config.h.in	2005-02-24 23:53:17.000000000 +0900
+++ jfbterm-0.4.7/config.h.in	2005-12-17 12:41:37.000000000 +0900
@@ -1,46 +1,4 @@
-/* config.h.in.  Generated automatically from configure.in by autoheader 2.13.  */
-
-/* Define to empty if the keyword does not work.  */
-#undef const
-
-/* Define if you don't have vprintf but do have _doprnt.  */
-#undef HAVE_DOPRNT
-
-/* Define if you have a working `mmap' system call.  */
-#undef HAVE_MMAP
-
-/* Define if your struct stat has st_rdev.  */
-#undef HAVE_ST_RDEV
-
-/* Define if you have <sys/wait.h> that is POSIX.1 compatible.  */
-#undef HAVE_SYS_WAIT_H
-
-/* Define if you have the vprintf function.  */
-#undef HAVE_VPRINTF
-
-/* Define as __inline if that's what the C compiler calls it.  */
-#undef inline
-
-/* Define if major, minor, and makedev are declared in <mkdev.h>.  */
-#undef MAJOR_IN_MKDEV
-
-/* Define if major, minor, and makedev are declared in <sysmacros.h>.  */
-#undef MAJOR_IN_SYSMACROS
-
-/* Define to `long' if <sys/types.h> doesn't define.  */
-#undef off_t
-
-/* Define as the return type of signal handlers (int or void).  */
-#undef RETSIGTYPE
-
-/* Define to `unsigned' if <sys/types.h> doesn't define.  */
-#undef size_t
-
-/* Define if you have the ANSI C header files.  */
-#undef STDC_HEADERS
-
-/* Define if you can safely include both <sys/time.h> and <time.h>.  */
-#undef TIME_WITH_SYS_TIME
+/* config.h.in.  Generated from configure.in by autoheader.  */
 
 /* Enable debugging codes. */
 #undef DEBUG
@@ -60,6 +18,9 @@
 /* Support 2bpp */
 #undef JFB_2BPP
 
+/* Support 4bpp */
+#undef JFB_4BPP
+
 /* Support 8bpp */
 #undef JFB_8BPP
 
@@ -105,45 +66,149 @@
 /* Supprt Dimmer (Screen blank) */
 #undef JFB_ENABLE_DIMMER
 
+/* Support beep */
+#undef JFB_ENABLE_BEEP
+
+/* Support blinking cursor */
+#undef JFB_ENABLE_CURSOR_BLINK
+
+/* Support console scrollback emulation */
+#undef JFB_ENABLE_SCROLLBACK
+
+/* Support libhangul input */
+#undef JFB_WITH_LIBHANGUL
+
 /* Support reverse video */
 #undef JFB_REVERSEVIDEO
 
-/* Define if you have the getpagesize function.  */
+/* Define to 1 if you don't have `vprintf' but do have `_doprnt.' */
+#undef HAVE_DOPRNT
+
+/* Define to 1 if you have the <fcntl.h> header file. */
+#undef HAVE_FCNTL_H
+
+/* Define to 1 if you have the `getpagesize' function. */
 #undef HAVE_GETPAGESIZE
 
-/* Define if you have the ioperm function.  */
+/* Define to 1 if you have the <inttypes.h> header file. */
+#undef HAVE_INTTYPES_H
+
+/* Define to 1 if you have the `ioperm' function. */
 #undef HAVE_IOPERM
 
-/* Define if you have the select function.  */
+/* Define to 1 if you have the `hangul' library (-lhangul). */
+#undef HAVE_LIBHANGUL
+
+/* Define to 1 if you have the `m' library (-lm). */
+#undef HAVE_LIBM
+
+/* Define to 1 if you have the <malloc.h> header file. */
+#undef HAVE_MALLOC_H
+
+/* Define to 1 if you have the <memory.h> header file. */
+#undef HAVE_MEMORY_H
+
+/* Define to 1 if you have a working `mmap' system call. */
+#undef HAVE_MMAP
+
+/* Define to 1 if you have the `select' function. */
 #undef HAVE_SELECT
 
-/* Define if you have the strdup function.  */
+/* Define to 1 if you have the <stdint.h> header file. */
+#undef HAVE_STDINT_H
+
+/* Define to 1 if you have the <stdlib.h> header file. */
+#undef HAVE_STDLIB_H
+
+/* Define to 1 if you have the `strdup' function. */
 #undef HAVE_STRDUP
 
-/* Define if you have the strerror function.  */
+/* Define to 1 if you have the `strerror' function. */
 #undef HAVE_STRERROR
 
-/* Define if you have the <fcntl.h> header file.  */
-#undef HAVE_FCNTL_H
+/* Define to 1 if you have the <strings.h> header file. */
+#undef HAVE_STRINGS_H
 
-/* Define if you have the <malloc.h> header file.  */
-#undef HAVE_MALLOC_H
+/* Define to 1 if you have the <string.h> header file. */
+#undef HAVE_STRING_H
+
+/* Define to 1 if `st_rdev' is member of `struct stat'. */
+#undef HAVE_STRUCT_STAT_ST_RDEV
 
-/* Define if you have the <sys/ioctl.h> header file.  */
+/* Define to 1 if your `struct stat' has `st_rdev'. Deprecated, use
+   `HAVE_STRUCT_STAT_ST_RDEV' instead. */
+#undef HAVE_ST_RDEV
+
+/* Define to 1 if you have the <sys/ioctl.h> header file. */
 #undef HAVE_SYS_IOCTL_H
 
-/* Define if you have the <sys/time.h> header file.  */
+/* Define to 1 if you have the <sys/stat.h> header file. */
+#undef HAVE_SYS_STAT_H
+
+/* Define to 1 if you have the <sys/time.h> header file. */
 #undef HAVE_SYS_TIME_H
 
-/* Define if you have the <unistd.h> header file.  */
+/* Define to 1 if you have the <sys/types.h> header file. */
+#undef HAVE_SYS_TYPES_H
+
+/* Define to 1 if you have <sys/wait.h> that is POSIX.1 compatible. */
+#undef HAVE_SYS_WAIT_H
+
+/* Define to 1 if you have the <unistd.h> header file. */
 #undef HAVE_UNISTD_H
 
-/* Define if you have the m library (-lm).  */
-#undef HAVE_LIBM
+/* Define to 1 if you have the `vprintf' function. */
+#undef HAVE_VPRINTF
+
+/* Define to 1 if `major', `minor', and `makedev' are declared in <mkdev.h>.
+   */
+#undef MAJOR_IN_MKDEV
+
+/* Define to 1 if `major', `minor', and `makedev' are declared in
+   <sysmacros.h>. */
+#undef MAJOR_IN_SYSMACROS
 
 /* Name of package */
 #undef PACKAGE
 
+/* Define to the address where bug reports for this package should be sent. */
+#undef PACKAGE_BUGREPORT
+
+/* Define to the full name of this package. */
+#undef PACKAGE_NAME
+
+/* Define to the full name and version of this package. */
+#undef PACKAGE_STRING
+
+/* Define to the one symbol short name of this package. */
+#undef PACKAGE_TARNAME
+
+/* Define to the version of this package. */
+#undef PACKAGE_VERSION
+
+/* Define as the return type of signal handlers (`int' or `void'). */
+#undef RETSIGTYPE
+
+/* Define to 1 if you have the ANSI C header files. */
+#undef STDC_HEADERS
+
+/* Define to 1 if you can safely include both <sys/time.h> and <time.h>. */
+#undef TIME_WITH_SYS_TIME
+
 /* Version number of package */
 #undef VERSION
 
+/* Define to empty if `const' does not conform to ANSI C. */
+#undef const
+
+/* Define to `__inline__' or `__inline' if that's what the C compiler
+   calls it, or to nothing if 'inline' is not supported under any name.  */
+#ifndef __cplusplus
+#undef inline
+#endif
+
+/* Define to `long' if <sys/types.h> does not define. */
+#undef off_t
+
+/* Define to `unsigned' if <sys/types.h> does not define. */
+#undef size_t
diff -uNr jfbterm-0.4.7.orig/configure.in jfbterm-0.4.7/configure.in
--- jfbterm-0.4.7.orig/configure.in	2005-02-25 00:01:05.000000000 +0900
+++ jfbterm-0.4.7/configure.in	2005-12-17 12:41:37.000000000 +0900
@@ -43,7 +43,7 @@
 	AC_DEFINE_UNQUOTED(JFB_GZIP_PATH, "${jfb_gzip_path}")
 fi
 
-AC_ARG_ENABLE(colorgamma, [ --enable-color-gamma     turn on color gamma [default no]],,enable_colorgamma=no)
+AC_ARG_ENABLE(colorgamma, [  --enable-color-gamma    turn on color gamma [default no]],,enable_colorgamma=no)
 AC_MSG_CHECKING(whether to enable color gamma)
 if test x$enable_colorgamma = xyes; then
         AC_MSG_RESULT(yes)
@@ -51,7 +51,7 @@
 else
         AC_MSG_RESULT(no)
 fi
-AC_ARG_ENABLE(reverse-video, [ --enable-reverse-video   support reverse cmap [default no]],,enable_reverse_video=no)
+AC_ARG_ENABLE(reverse-video, [  --enable-reverse-video  support reverse cmap [default no]],,enable_reverse_video=no)
 AC_MSG_CHECKING(whether to enable reverse-video)
 if test x$enable_reverse_video = xyes; then
 	AC_MSG_RESULT(yes)
@@ -60,7 +60,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(debug, [ --enable-debug           turn on debugging [default no]],,enable_debug=no)
+AC_ARG_ENABLE(debug, [  --enable-debug          turn on debugging [default no]],,enable_debug=no)
 AC_MSG_CHECKING(whether to enable debugging)
 if test x$enable_debug = xyes; then
 	AC_MSG_RESULT(yes)
@@ -69,7 +69,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(utf8, [ --enable-utf8            support UTF-8 [default yes]],,enable_utf8=yes)
+AC_ARG_ENABLE(utf8, [  --enable-utf8           support UTF-8 [default yes]],,enable_utf8=yes)
 AC_MSG_CHECKING(whether to enable utf8)
 if test x$enable_utf8 = xyes; then
 	AC_MSG_RESULT(yes)
@@ -77,7 +77,7 @@
 else
 	AC_MSG_RESULT(no)
 fi
-AC_ARG_ENABLE(other-coding-system, [ --enable-other-coding-system support other-coding-system [default yes]],,enable_other=$enable_utf8)
+AC_ARG_ENABLE(other-coding-system, [  --enable-other-coding-system support other-coding-system [default yes]],,enable_other=$enable_utf8)
 AC_MSG_CHECKING(whether to enable other coding system)
 if test x$enable_utf8 = xyes -a x$enable_other = xyes; then
 	AC_MSG_RESULT(yes)
@@ -86,7 +86,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(1bpp, [ --enable-1bpp            support 1bpp [default no]],,enable_1bpp=no)
+AC_ARG_ENABLE(1bpp, [  --enable-1bpp           support 1bpp [default no]],,enable_1bpp=no)
 AC_MSG_CHECKING(whether to enable 1bpp)
 if test x$enable_1bpp = xyes; then
 	AC_MSG_RESULT(yes)
@@ -95,7 +95,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(2bpp, [ --enable-2bpp            support 2bpp [default yes]],,enable_2bpp=yes)
+AC_ARG_ENABLE(2bpp, [  --enable-2bpp           support 2bpp [default yes]],,enable_2bpp=yes)
 AC_MSG_CHECKING(whether to enable 2bpp)
 if test x$enable_2bpp = xyes; then
 	AC_MSG_RESULT(yes)
@@ -104,7 +104,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-dnl AC_ARG_ENABLE(4bpp, [ --enable-4bpp            support 4bpp [default no]],,enable_4bpp=no)
+dnl AC_ARG_ENABLE(4bpp, [  --enable-4bpp           support 4bpp [default no]],,enable_4bpp=no)
 dnl AC_MSG_CHECKING(whether to enable 4bpp)
 dnl if test x$enable_4bpp = xyes; then
 dnl	AC_MSG_RESULT(yes)
@@ -113,7 +113,7 @@
 dnl	AC_MSG_RESULT(no)
 dnl fi
 
-AC_ARG_ENABLE(8bpp, [ --enable-8bpp            support 8bpp [default yes]],,enable_8bpp=yes)
+AC_ARG_ENABLE(8bpp, [  --enable-8bpp           support 8bpp [default yes]],,enable_8bpp=yes)
 AC_MSG_CHECKING(whether to enable 8bpp)
 if test x$enable_8bpp = xyes; then
 	AC_MSG_RESULT(yes)
@@ -122,7 +122,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(15bpp, [ --enable-15bpp           support 15bpp [default yes]],,enable_15bpp=yes)
+AC_ARG_ENABLE(15bpp, [  --enable-15bpp          support 15bpp [default yes]],,enable_15bpp=yes)
 AC_MSG_CHECKING(whether to enable 15bpp)
 if test x$enable_15bpp = xyes; then
 	AC_MSG_RESULT(yes)
@@ -131,7 +131,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(16bpp, [ --enable-16bpp           support 16bpp [default yes]],,enable_16bpp=yes)
+AC_ARG_ENABLE(16bpp, [  --enable-16bpp          support 16bpp [default yes]],,enable_16bpp=yes)
 AC_MSG_CHECKING(whether to enable 16bpp)
 if test x$enable_16bpp = xyes; then
 	AC_MSG_RESULT(yes)
@@ -140,7 +140,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(24bpp, [ --enable-24bpp           support 24bpp [default yes]],,enable_24bpp=yes)
+AC_ARG_ENABLE(24bpp, [  --enable-24bpp          support 24bpp [default yes]],,enable_24bpp=yes)
 AC_MSG_CHECKING(whether to enable 24bpp)
 if test x$enable_24bpp = xyes; then
 	AC_MSG_RESULT(yes)
@@ -149,7 +149,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(32bpp, [ --enable-32bpp           support 32bpp [default yes]],,enable_32bpp=yes)
+AC_ARG_ENABLE(32bpp, [  --enable-32bpp          support 32bpp [default yes]],,enable_32bpp=yes)
 AC_MSG_CHECKING(whether to enable 32bpp)
 if test x$enable_32bpp = xyes; then
 	AC_MSG_RESULT(yes)
@@ -158,7 +158,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(pseudo-color, [ --enable-pseudo-color    support pseudo-color [default yes]],,enable_pseudo_color=yes)
+AC_ARG_ENABLE(pseudo-color, [  --enable-pseudo-color   support pseudo-color [default yes]],,enable_pseudo_color=yes)
 AC_MSG_CHECKING(whether to enable pseudo-color)
 if test x$enable_pseudo_color = xyes; then
 	AC_MSG_RESULT(yes)
@@ -167,7 +167,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(direct-color, [ --enable-direct-color    support direct-color (EXPERMINAL) [default no]],,enable_direct_color=no)
+AC_ARG_ENABLE(direct-color, [  --enable-direct-color   support direct-color (EXPERMINAL) [default no]],,enable_direct_color=no)
 AC_MSG_CHECKING(whether to enable direct-color)
 if test x$enable_direct_color = xyes; then
 	AC_MSG_RESULT(yes)
@@ -176,7 +176,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(true-color, [ --enable-true-color      support true-color [default yes]],,enable_true_color=yes)
+AC_ARG_ENABLE(true-color, [  --enable-true-color     support true-color [default yes]],,enable_true_color=yes)
 AC_MSG_CHECKING(whether to enable true-color)
 if test x$enable_true_color = xyes; then
 	AC_MSG_RESULT(yes)
@@ -185,7 +185,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(vga16fb, [ --enable-vga16fb         support vga16fb [default yes]],,enable_vga16fb=yes)
+AC_ARG_ENABLE(vga16fb, [  --enable-vga16fb        support vga16fb [default yes]],,enable_vga16fb=yes)
 AC_MSG_CHECKING(whether to enable vga16fb)
 if test x$enable_vga16fb = xyes; then
 	AC_MSG_RESULT(yes)
@@ -199,7 +199,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(packed-pixels, [ --enable-packed-pixels         support packed-pixels [default yes]],,enable_packed_pixels=yes)
+AC_ARG_ENABLE(packed-pixels, [  --enable-packed-pixels  support packed-pixels [default yes]],,enable_packed_pixels=yes)
 AC_MSG_CHECKING(whether to enable packed-pixels)
 if test x$enable_packed_pixels = xyes; then
 	AC_MSG_RESULT(yes)
@@ -208,7 +208,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(check-mmio-error, [ --enable-check-mmio-error         Check mmap(mmio) return code [default no]],,enable_check_mmio_error=no)
+AC_ARG_ENABLE(check-mmio-error, [  --enable-check-mmio-error Check mmap(mmio) return code [default no]],,enable_check_mmio_error=no)
 AC_MSG_CHECKING(whether to enable check-mmio-error)
 if test x$enable_check_mmio_error = xyes; then
 	AC_MSG_RESULT(yes)
@@ -217,7 +217,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(force-8bit, [ --enable-force-8bit         Force 8bit Color [default no]],,enable_force_8bit=no)
+AC_ARG_ENABLE(force-8bit, [  --enable-force-8bit     Force 8bit Color [default no]],,enable_force_8bit=no)
 AC_MSG_CHECKING(whether to enable force-8bit)
 if test x$enable_force_8bit = xyes; then
 	AC_MSG_RESULT(yes)
@@ -226,7 +226,7 @@
 	AC_MSG_RESULT(no)
 fi
 
-AC_ARG_ENABLE(dimmer, [ --enable-dimmer          Enable auto dimmer (condole blank) [default no]],,enable_dimmer=no)
+AC_ARG_ENABLE(dimmer, [  --enable-dimmer         Enable auto dimmer (console blank) [default no]],,enable_dimmer=no)
 AC_MSG_CHECKING(whether to enable dimmer)
 if test x$enable_dimmer = xyes; then
 	AC_MSG_RESULT(yes)
@@ -235,6 +235,51 @@
 	AC_MSG_RESULT(no)
 fi
 
+AC_ARG_ENABLE(beep, [  --enable-beep           Enable beep [default yes]],,enable_beep=yes)
+AC_MSG_CHECKING(whether to enable beep)
+if test x$enable_beep = xyes; then
+	AC_MSG_RESULT(yes)
+	AC_DEFINE(JFB_ENABLE_BEEP)
+else
+	AC_MSG_RESULT(no)
+fi
+
+AC_ARG_ENABLE(cursor-blink, [  --enable-cursor-blink   Enable blinking cursor [default yes]],,enable_cursor_blink=yes)
+AC_MSG_CHECKING(whether to enable blinking cursor)
+if test x$enable_cursor_blink = xyes; then
+	AC_MSG_RESULT(yes)
+	AC_DEFINE(JFB_ENABLE_CURSOR_BLINK)
+else
+	AC_MSG_RESULT(no)
+fi
+
+AC_ARG_ENABLE(scrollback, [  --enable-scrollback     Enable console scrollback emulation [default yes]],,enable_scrollback=yes)
+AC_MSG_CHECKING(whether to enable scrollback emulation)
+if test x$enable_scrollback = xyes; then
+	AC_MSG_RESULT(yes)
+	AC_DEFINE(JFB_ENABLE_SCROLLBACK)
+else
+	AC_MSG_RESULT(no)
+fi
+
+AC_CHECK_PROGS(jfb_pkg_config, pkg-config)
+AC_CHECK_LIB(hangul, hangul_ic_new,,with_libhangul=no)
+AC_ARG_WITH(libhangul, [  --with-libhangul        Use libhangul input [default yes]],,with_libhangul=yes)
+AC_MSG_CHECKING(whether to use libhangul)
+
+if test x$jfb_pkg_config = xpkg-config; then
+	if test x$with_libhangul = xyes; then
+		AC_MSG_RESULT(yes)
+		AC_DEFINE(JFB_WITH_LIBHANGUL)
+		CFLAGS="$CFLAGS `pkg-config --cflags libhangul`"
+		LDFLAGS="$LDFLAGS `pkg-config --libs libhangul`"
+	else
+		AC_MSG_RESULT(no)
+	fi
+else
+	AC_MSG_RESULT(no (pkg-config missing))
+fi
+
 if test x$sysconfdir = 'x${prefix}/etc'; then
 	if test x$prefix = xNONE; then
 		AC_DEFINE_UNQUOTED(SYSCONFDIR, "/usr/local/etc")
diff -uNr jfbterm-0.4.7.orig/conv.c jfbterm-0.4.7/conv.c
--- jfbterm-0.4.7.orig/conv.c	1970-01-01 09:00:00.000000000 +0900
+++ jfbterm-0.4.7/conv.c	2005-12-17 12:41:37.000000000 +0900
@@ -0,0 +1,122 @@
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+#ifdef JFB_WITH_LIBHANGUL
+#include <stdio.h>
+#include <iconv.h>
+#include <endian.h>
+#include <string.h>
+#include "conv.h"
+
+int
+conv_str(const char *fromenc, const char *toenc, unsigned char *fromstr, unsigned char *tostr)
+{
+	int inbytesleft, outbytesleft, convbytes;
+	char *inbuf, *outbuf;
+
+	size_t ret = (size_t)-1;
+	iconv_t cd = (iconv_t)-1;
+
+	inbuf = fromstr;
+	outbuf = tostr;
+
+	cd = iconv_open(toenc, fromenc);
+	if(cd == (iconv_t)-1) {
+		return -1;
+	}
+
+	if(!strncmp(fromenc, "UCS-4", 5)) {
+		int size = 0;
+#if __BYTE_ORDER == __BIG_ENDIAN
+		/* FIXME: not tested */
+		int i, temp;
+		while(fromstr[size * 4 + 3] != 0) {
+			if(size > CONV_SIZE * 4)
+				break;
+			size++;
+		}
+		inbytesleft = size * 4;
+#elif __BYTE_ORDER == __LITTLE_ENDIAN
+		int i;
+		unsigned char temp;
+		while(fromstr[size * 4] != 0 ||
+		      fromstr[size * 4 + 1] != 0 ||
+		      fromstr[size * 4 + 2] != 0 ||
+		      fromstr[size * 4 + 3] != 0) {
+			if(size > CONV_SIZE * 4)
+				break;
+			size++;
+		}
+		inbytesleft = size * 4;
+
+		/* swap bytes */
+		for(i = 0; i < size; i++) {
+			temp = fromstr[i * 4];
+			fromstr[i * 4] = fromstr[i * 4 + 3];
+			fromstr[i * 4 + 3] = temp;
+
+			temp = fromstr[i * 4 + 1];
+			fromstr[i * 4 + 1] = fromstr[i * 4 + 2];
+			fromstr[i * 4 + 2] = temp;
+		}
+#else
+#error "FIXME: endian type undefined"
+#endif
+	}
+	else {
+		inbytesleft = strlen(fromstr);
+	}
+	outbytesleft = CONV_SIZE;
+	ret = iconv(cd, &inbuf, &inbytesleft, &outbuf, &outbytesleft);
+
+	if(ret == (size_t)-1) {
+		iconv_close(cd);
+		return -1;
+	}
+	iconv_close(cd);
+
+	convbytes = CONV_SIZE - outbytesleft;
+
+#if __BYTE_ORDER == __LITTLE_ENDIAN
+	if(!strncmp(toenc, "UCS-4", 5)) {
+		int i;
+		unsigned char temp;
+		/* swap bytes */
+		for(i = 0; i < convbytes; i++) {
+			temp = tostr[i * 4];
+			tostr[i * 4] = tostr[i * 4 + 3];
+			tostr[i * 4 + 3] = temp;
+
+			temp = tostr[i * 4 + 1];
+			tostr[i * 4 + 1] = tostr[i * 4 + 2];
+			tostr[i * 4 + 2] = temp;
+		}
+		convbytes = convbytes / 4;
+	}
+#endif
+	return convbytes;
+}
+
+#if 0
+int
+main(void)
+{
+	unsigned int ucs4str[CONV_SIZE] = {0, };
+	unsigned char utf8str[] = "한글rㄱ";
+	unsigned char utf8str2[CONV_SIZE] = {0, };
+	int ret;
+	fprintf(stderr, "ORIG: %s\r\n", utf8str);
+	//ret = CONV_euckr_to_utf8(utf8str, utf8str2);
+	ret = CONV_utf8_to_ucs4(utf8str, (char *)ucs4str);
+	fprintf(stderr, "[%d]%s\r\n", ret, utf8str);
+	int i = 0;
+	for(i = 0; i < CONV_SIZE; i++) {
+		fprintf(stderr, "[%d] ", ucs4str[i]);
+	}
+	ret = CONV_ucs4_to_utf8((char *)ucs4str, utf8str2);
+	fprintf(stderr, "[%d]%s\r\n", ret, utf8str2);
+	fprintf(stderr, "END\r\n");
+	return 0;
+}
+#endif
+#endif
diff -uNr jfbterm-0.4.7.orig/conv.h jfbterm-0.4.7/conv.h
--- jfbterm-0.4.7.orig/conv.h	1970-01-01 09:00:00.000000000 +0900
+++ jfbterm-0.4.7/conv.h	2005-12-17 12:41:37.000000000 +0900
@@ -0,0 +1,15 @@
+#ifdef JFB_WITH_LIBHANGUL
+#ifndef INCLUDE_CONV_H
+#define INCLUDE_CONV_H
+int conv_str(const char *fromenc, const char *toenc, unsigned char *fromstr, unsigned char *tostr);
+#define CONV_SIZE 32
+#define CONV_ucs4_to_utf8(x, y) conv_str("UCS-4", "UTF-8", (x), (y))
+#define CONV_utf8_to_ucs4(x, y) conv_str("UTF-8", "UCS-4", (x), (y))
+#define CONV_euckr_to_utf8(x, y) conv_str("EUC-KR", "UTF-8", (x), (y))
+#define CONV_utf8_to_euckr(x, y) conv_str("UTF-8", "EUC-KR", (x), (y))
+
+/* XXX: doesn't work. why? */
+#define CONV_ucs4_to_euckr(x, y) conv_str("EUC-KR", "UCS-4", (x), (y))
+#define CONV_euckr_to_ucs4(x, y) conv_str("UCS-4", "EUC-KR", (x), (y))
+#endif /* INCLUDE_CONV_H */
+#endif /* JFB_WITH_LIBHANGUL */
diff -uNr jfbterm-0.4.7.orig/hinput.c jfbterm-0.4.7/hinput.c
--- jfbterm-0.4.7.orig/hinput.c	1970-01-01 09:00:00.000000000 +0900
+++ jfbterm-0.4.7/hinput.c	2005-12-17 12:41:37.000000000 +0900
@@ -0,0 +1,250 @@
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+#ifdef JFB_WITH_LIBHANGUL
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <locale.h>
+#include <langinfo.h>
+#include <sys/ioctl.h>
+#include <hangul.h>
+#include "conv.h"
+#include "hinput.h"
+
+HangulInputContext *hic = NULL;
+
+static int hkeyboard;
+int hinput_encoding;
+
+/* internal use only */
+int get_shift_state(void)
+{
+	int na = 6, ns = 0;
+	if(ioctl(fileno(stdin), TIOCLINUX, &na) == 0) ns = na;
+	return ns;
+}
+
+int hinput_init(char *keyboard_type, char *input_encoding)
+{
+	if(!keyboard_type || strcmp(keyboard_type, "2") == 0)
+		hkeyboard = HANGUL_KEYBOARD_2;
+	else if(strcmp(keyboard_type, "32") == 0)
+		hkeyboard = HANGUL_KEYBOARD_32;
+	else if(strcmp(keyboard_type, "3final") == 0 ||
+		strcmp(keyboard_type, "3") == 0)
+		hkeyboard = HANGUL_KEYBOARD_3FINAL;
+	else if(strcmp(keyboard_type, "390") == 0)
+		hkeyboard = HANGUL_KEYBOARD_390;
+	else if(strcmp(keyboard_type, "3noshift") == 0)
+		hkeyboard = HANGUL_KEYBOARD_3NOSHIFT;
+	else if(strcmp(keyboard_type, "3yetgul") == 0)
+		hkeyboard = HANGUL_KEYBOARD_3YETGUL;
+	else {
+		hkeyboard = HANGUL_KEYBOARD_NONE;
+		hinput_encoding = HINPUT_ENCODING_NONE;
+		return 1;
+	}
+	
+	if(!input_encoding || strcmp(input_encoding, "locale") == 0) {
+		setlocale(LC_ALL, "");
+		input_encoding = nl_langinfo(CODESET);
+	}
+	if(strcmp(input_encoding, "UTF-8") == 0 ||
+	   strcmp(input_encoding, "utf-8") == 0 ||
+	   strcmp(input_encoding, "UTF8") == 0 ||
+	   strcmp(input_encoding, "utf8") == 0) {
+		hic = hangul_ic_new(hkeyboard);
+		if(hic == NULL) {
+			hinput_encoding = HINPUT_ENCODING_NONE;
+			return 0;
+		}
+		hinput_encoding = HINPUT_ENCODING_UTF8;
+	}
+	else if(strcmp(input_encoding, "EUC-KR") == 0 ||
+		strcmp(input_encoding, "euc-kr") == 0 ||
+		strcmp(input_encoding, "EUCKR") == 0 ||
+		strcmp(input_encoding, "euckr") == 0 ||
+		strcmp(input_encoding, "eucKR") == 0) {
+		hic = hangul_ic_new(hkeyboard);
+		if(hic == NULL) {
+			hinput_encoding = HINPUT_ENCODING_NONE;
+			return 0;
+		}
+		hinput_encoding = HINPUT_ENCODING_EUCKR;
+	}
+	else
+		hinput_encoding = HINPUT_ENCODING_NONE;
+		
+	return 1;
+}
+
+void hinput_exit(void)
+{
+	if(hic != NULL)
+		hangul_ic_delete(hic);
+}
+
+int hinput_try_commit(TTerm *p, u_int *commit_flag)
+{
+	u_char commit[CONV_SIZE] = {0, };
+	u_char commit_temp[CONV_SIZE] = {0, };
+	ucschar *commit_ucs4;
+	u_int ret;
+
+	commit_ucs4 = hangul_ic_get_commit_string(hic);
+	if(hinput_encoding == HINPUT_ENCODING_UTF8) {
+		ret = CONV_ucs4_to_utf8((char *)commit_ucs4, commit);
+		if(ret == -1) // iconv error
+			return 0;
+	}
+	else if(hinput_encoding == HINPUT_ENCODING_EUCKR) {
+		/* iconv from ucs4 to euc-kr doesn't work. why? */
+		ret = CONV_ucs4_to_utf8((char *)commit_ucs4, commit_temp);
+		if(ret == -1) // iconv error
+			return 0;
+		ret = CONV_utf8_to_euckr(commit_temp, commit);
+		if(ret == -1)
+			return 0;
+	}
+	else { // unknown encoding
+		return 0;
+	}
+
+	if(strlen(commit) > 0) {
+		write(p->ptyfd, commit, strlen(commit));
+		*commit_flag = 1;
+	}
+	return 1;
+}
+
+int hinput_try_preedit(TTerm *p, u_int state, u_int *commit_flag)
+{
+	u_char preedit[CONV_SIZE] = {0, };
+	u_char preedit_temp[CONV_SIZE] = {0, };
+	static u_char preedit_save[CONV_SIZE];
+	ucschar *preedit_ucs4;
+	u_int ret;
+
+	if(state == 1 && *commit_flag == 1) {
+		// process preedit after commit (if any)
+		if(strlen(preedit_save) > 0) {
+			int i;
+			tvterm_emulate(&(p->vterm), preedit_save, strlen(preedit_save));
+			p->vterm.pen.x -= 2;
+			tvterm_refresh(&(p->vterm));
+			for(i = 0; i < CONV_SIZE; i++) {
+				preedit_save[i] = 0;
+			}
+		}
+		*commit_flag = 0;
+		return 1;
+	}
+
+	preedit_ucs4 = hangul_ic_get_preedit_string(hic);
+	if(hinput_encoding == HINPUT_ENCODING_UTF8) {
+		ret = CONV_ucs4_to_utf8((char *)preedit_ucs4, preedit);
+		if(ret == -1) // iconv error
+			return 0;
+	}
+	else if(hinput_encoding == HINPUT_ENCODING_EUCKR) {
+		/* iconv from ucs4 to euc-kr doesn't work. */
+		ret = CONV_ucs4_to_utf8((char *)preedit_ucs4, preedit_temp);
+		if(ret == -1) // iconv_error
+			return 0;
+		ret = CONV_utf8_to_euckr(preedit_temp, preedit);
+		if(ret == -1) {
+			/* XXX: temporary fix */
+			return -1;
+		}
+	}
+	else { // unknown encoding
+		return 0;
+	}
+	if(strlen(preedit) >= 0 && state == 0 && *commit_flag == 0) {
+		if(strlen(preedit) == 0) {
+			preedit[0] = ' ';
+			preedit[1] = ' ';
+			preedit[2] = 0;
+		}
+		if(strlen(preedit) > 3) {
+			/* XXX: temporary fix for preedit for more than 1 character :( */
+			if(hinput_encoding == HINPUT_ENCODING_UTF8)
+				preedit[3] = 0;
+			else if(hinput_encoding == HINPUT_ENCODING_EUCKR)
+				preedit[2] = 0;
+		}
+		tvterm_emulate(&(p->vterm), preedit, strlen(preedit));
+		p->vterm.pen.x -= 2;
+		tvterm_refresh(&(p->vterm));
+	}
+	else if(strlen(preedit) > 0 && state == 0 && *commit_flag == 1) {
+		// save preedit char for processing after commit
+		if(strlen(preedit) > 3) {
+			/* XXX: temporary fix for preedit for more than 1 character :( */
+			if(hinput_encoding == HINPUT_ENCODING_UTF8)
+				preedit[3] = 0;
+			else if(hinput_encoding == HINPUT_ENCODING_EUCKR)
+				preedit[2] = 0;
+		}
+		strncpy(preedit_save, preedit, CONV_SIZE);
+	}
+	return 1;
+}
+
+int hinput_process(TTerm *p, u_char *buf, int ret, u_int *preedit_after_commit)
+{
+	static u_int hstate = 0;
+	u_int i, c, fret;
+	if(buf[0] == KEY_ESC && hstate) {
+		hangul_ic_flush(hic);
+		hinput_try_commit(p, preedit_after_commit);
+		hstate = 0;
+	}
+	if(ret == 1 && buf[0] == KEY_SPACE && get_shift_state()) {
+		if(hstate) {
+			hangul_ic_flush(hic);
+			hinput_try_commit(p, preedit_after_commit);
+			hstate = 0;
+		}
+		else
+			hstate = 1;
+	}
+	else if(hstate) {
+		for(i = 0; i < ret; i++) {
+			c = buf[i];
+			if(c == KEY_BACKSPACE) {
+				if(!hangul_ic_backspace(hic)) {
+					write(p->ptyfd, &c, 1);
+					*preedit_after_commit = 1;
+				}
+				continue;
+			}
+			fret = hangul_ic_filter(hic, c);
+			if(!fret) {
+				hinput_try_commit(p, preedit_after_commit);
+				write(p->ptyfd, &c, 1);
+				*preedit_after_commit = 1;
+				continue;
+			}
+			hinput_try_commit(p, preedit_after_commit);
+		}
+		if(hinput_try_preedit(p, 0, preedit_after_commit) == -1) {
+			/*
+			 *  XXX: temporary fix for non EUC-KR chars in EUC-KR locale
+			 *       will be deleted when censor functionality is added
+			 *       to libhangul
+			 */
+			hangul_ic_backspace(hic);
+			hangul_ic_flush(hic);
+			hinput_try_commit(p, preedit_after_commit);
+			hangul_ic_filter(hic, c);
+			hinput_try_preedit(p, 0, preedit_after_commit);
+		}
+	}
+	else
+		return 0;
+	return 1;
+}
+#endif
diff -uNr jfbterm-0.4.7.orig/hinput.h jfbterm-0.4.7/hinput.h
--- jfbterm-0.4.7.orig/hinput.h	1970-01-01 09:00:00.000000000 +0900
+++ jfbterm-0.4.7/hinput.h	2005-12-17 12:41:37.000000000 +0900
@@ -0,0 +1,23 @@
+#ifdef JFB_WITH_LIBHANGUL
+#ifndef INCLUDE_HINPUT_H
+#define INCLUDE_HINPUT_H
+#include "term.h"
+
+#define KEY_ESC 0x1B
+#define KEY_SPACE 0x20
+#define KEY_BACKSPACE 0x7F
+
+#define HANGUL_KEYBOARD_NONE -1
+enum {
+	HINPUT_ENCODING_NONE,
+	HINPUT_ENCODING_UTF8,
+	HINPUT_ENCODING_EUCKR
+};
+
+int hinput_init(char *keyboard_type, char *input_encoding);
+void hinput_exit(void);
+int hinput_try_commit(TTerm *p, u_int *commit_flag);
+int hinput_try_preedit(TTerm *p, u_int state, u_int *commit_flag);
+int hinput_process(TTerm *p, u_char *buf, int ret, u_int *preedit_after_commit);
+#endif /* INCLUDE_HINPUT_H */
+#endif /* JFB_WITH_LIBHANGUL */
